/*****************************************************************************

  utils.hpp
  
     Miscelaneous utilities for the whole library
     
   This file belongs to the KisTA library
   All rights reserved by the authors (until further License definition)

  Author: F. Herrera
  Institution: KTH
  Deparment:   ICT / Electronic Systems
  Date: 2014 February

 *****************************************************************************/


#ifndef UTILS_HPP
#define UTILS_HPP

#include "systemc.h"

namespace kista {

// checks
// to ensure that a call is done before simulation start
void check_call_before_sim_start(std::string call_name);
// to ensure that a call is done after simulation start
void check_call_after_sim_start(std::string call_name);

// units

// conversion factor for data rates
double conv_data_rate_factor(char unit);
// conversion factor for internation system unit
double conv_isu_factor(char unit);

} // end namespace kista

#endif


